{
  description = "System Configuration Flake";

  
  outputs = inputs@{ 
    nixpkgs,
    home-manager,
    osu-nixos,
    ...
  } : {

    nixosConfigurations = {
      malachite = nixpkgs.lib.nixosSystem {
        system = "x86_64-linux";
        specialArgs = { inherit inputs; };
        modules = [

          ./packages/default.nix
          ./hosts/malachite/default.nix
          ./users/stitchynyan/default.nix

          home-manager.nixosModules.home-manager
          {
             home-manager.extraSpecialArgs = {inherit inputs;};
             home-manager.useGlobalPkgs = true;
             home-manager.useUserPackages = true;
             home-manager.users.stitchynyan = import ./users/stitchynyan/home.nix;
          }
        ];
      };
      lappy = nixpkgs.lib.nixosSystem {
        system = "x86_64-linux";
        specialArgs = { inherit inputs; };
        modules = [

          ./packages/default.nix
          ./hosts/lappy/default.nix
          ./users/stitchynyan/default.nix

          home-manager.nixosModules.home-manager
          {
             home-manager.extraSpecialArgs = {inherit inputs;};
             home-manager.useGlobalPkgs = true;
             home-manager.useUserPackages = true;
             home-manager.users.stitchynyan = import ./users/stitchynyan/home.nix;
          }
        ];
      };
      gemini = nixpkgs.lib.nixosSystem {
        system = "x86_64-linux";
        specialArgs = { inherit inputs; };
        modules = [

          ./packages/default.nix
          ./hosts/gemini/default.nix
          ./users/nyadmin/default.nix

          home-manager.nixosModules.home-manager
          {
             home-manager.extraSpecialArgs = {inherit inputs;};
             home-manager.useGlobalPkgs = true;
             home-manager.useUserPackages = true;
             home-manager.users.nyadmin = import ./users/nyadmin/home.nix;
          }
        ];
      };
    };
  };

  inputs = {
    mobile-nixos = {
      url = "github:nixos/mobile-nixos";
      flake = false;
    };
    nixpkgs = {
      url = "github:NixOS/nixpkgs/nixos-unstable";
    };
    home-manager = {
      url = "github:nix-community/home-manager/master";
        inputs.nixpkgs.follows = "nixpkgs";
    };
    osu-nixos.url = "github:Asqiir/osu-nixos";
  };
}
